/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package it.tidalwave.openrdf.elmo;

import javax.annotation.Nonnull;
import java.util.Set;
import org.openrdf.elmo.Entity;
import org.openrdf.concepts.owl.Thing;
import it.tidalwave.util.As;
import it.tidalwave.util.Finder;
import it.tidalwave.semantic.OwlThing;
import it.tidalwave.semantic.Wrapper;

/***********************************************************************************************************************
 *
 * @author Fabrizio Giudici
 * @version $Id: ElmoOwlThing.java,v 1c263a6d8ac9 2010/02/14 00:23:33 fabrizio $
 *
 **********************************************************************************************************************/
public class ElmoOwlThing implements OwlThing
  {
    @Nonnull
    private final As object;

    /*******************************************************************************************************************
     *
     *
     ******************************************************************************************************************/
    public ElmoOwlThing (final @Nonnull As object)
      {
        this.object = object;
      }

    /*******************************************************************************************************************
     *
     * FIXME: this is similar to as(type), but it has a different exception policy. as() throws an AsException, which
     * is a RuntimeException.
     *
     ******************************************************************************************************************/
    @Nonnull
    @Override
//    public <T> Finder<T> findSameAsOfType (final @Nonnull Class<T> type)
    public <T> Finder<T> findSameAs()
      {
        return new ElmoFinder<T>("PREFIX owl: <http://www.w3.org/2002/07/owl#>\n")
          {
            @Override
            @Nonnull
            protected Finder<T> createClone()
              {
                throw new UnsupportedOperationException("Not supported yet."); // FIXME
              }

            @Override
            protected void process (final @Nonnull Set<String> auxStatements)
              {
                idMapByPlaceHolder.put("id", object.as(Entity.class).getQName());
                auxStatements.add(String.format("{ ?id owl:sameAs ?%s } UNION { ?%s owl:sameAs ?id }", entityName, entityName));
              }
          };
      }

    /*******************************************************************************************************************
     *
     *
     ******************************************************************************************************************/
    @Override
    public void addSameAs (final @Nonnull As other)
      {
        final Thing unwrappedObject1 = Wrapper.unwrap(object.as(Thing.class));
        final Thing unwrappedObject2 = Wrapper.unwrap(other.as(Thing.class));
        unwrappedObject1.getOwlSameAs().add(unwrappedObject2);
//            ((Thing)geoNode).getOwlSameAs().add((Thing)entity); // FIXME: see note in Utils.findSameAs()
      }
  }
