/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package it.tidalwave.semantic;

import javax.annotation.Nonnull;
import java.util.Collections;
import java.util.Locale;
import java.util.SortedSet;
import java.util.TreeSet;
import org.openrdf.elmo.Entity;
import org.openrdf.elmo.LiteralManager;
import org.openrdf.elmo.sesame.SesameManager;
import org.openrdf.model.Literal;
import org.openrdf.model.Resource;
import org.openrdf.model.Statement;
import org.openrdf.model.URI;
import org.openrdf.model.Value;
import org.openrdf.model.impl.URIImpl;
import org.openrdf.repository.RepositoryException;
import org.openrdf.repository.RepositoryResult;
import it.tidalwave.openrdf.elmo.ElmoManagerThreadLocal;

/**
 *
 * @author fritz
 */
public class SkosConceptUtils  
  {
    private SkosConceptUtils()
      {
      }
    
    /***************************************************************************
     *
     * @deprecated  Use ElmoSKOSConcept instead
     *
     **************************************************************************/
    public static void setDisplayName (@Nonnull final Object entity,
                                       @Nonnull final String displayName)
      {
        final SesameManager em = getSesameManager();
        setDisplayName(entity, displayName, em.getLocale());
      }

    /***************************************************************************
     *
     * @deprecated  Use ElmoSKOSConcept instead
     *
     **************************************************************************/
    public static void setDisplayName (@Nonnull final Object entity,
                                       @Nonnull final String displayName,
                                       @Nonnull final Locale locale)
      {
        final SesameManager em = getSesameManager();
        final LiteralManager<URI, Literal> literalManager = em.getLiteralManager();
        final Literal literal = (locale != null) ? literalManager.getLiteral(displayName, locale.getLanguage())
                                                 : literalManager.getLiteral(displayName);
        final URI predicate = new URIImpl("http://www.w3.org/2004/02/skos/core#prefLabel"); // FIXME
        try
          {
            final Resource entityResource = em.getResourceManager().createResource(((Entity)entity).getQName());
            em.getConnection().add(entityResource, predicate, literal);
          }
        catch (RepositoryException e)
          {
            throw new RuntimeException(e);
          }
      }

    /***************************************************************************
     *
     * @deprecated  Use ElmoSKOSConcept instead
     *
     **************************************************************************/
    @Nonnull
    public static String getDisplayName (@Nonnull final Object entity)
      {
        return getDisplayName(entity, null);
      }

    /***************************************************************************
     *
     * @deprecated  Use ElmoSKOSConcept instead
     *
     **************************************************************************/
    @Nonnull
    public static String getDisplayName (@Nonnull final Object entity,
                                         @Nonnull final Locale locale)
      {
        final SesameManager em = getSesameManager();
        final Resource entityResource = em.getResourceManager().createResource(((Entity)entity).getQName());
        final URI predicate = new URIImpl("http://www.w3.org/2004/02/skos/core#prefLabel"); // FIXME

        try
          {
            final RepositoryResult<Statement> statements = em.getConnection().getStatements(entityResource, predicate, null);
            String nonLocalizedValue = "";

            while (statements.hasNext())
              {
                final Statement statement = statements.next();
                final Value object = statement.getObject();

                if (object instanceof Literal)
                  {
                    final Literal literal = (Literal)object;
                    final String literalLanguage = literal.getLanguage();

                    if (literalLanguage == null)
                      {
                        nonLocalizedValue = literal.stringValue();
                        
                        if (locale == null)
                          {
                            return literal.stringValue();
                          }
                      }
                    else if ((locale != null) && literalLanguage.equals(locale.getLanguage()))
                      {
                        return literal.stringValue();
                      }
                  }
              }

            return nonLocalizedValue;
          }
        catch (RepositoryException e)
          {
            throw new RuntimeException(e);
          }
      }

    /***************************************************************************
     *
     * @deprecated  Use ElmoSKOSConcept instead
     *
     **************************************************************************/
    @Nonnull
    public static SortedSet<Locale> getLocales (@Nonnull final Object entity)
      {
        return new TreeSet<Locale>(Collections.singleton(Locale.ENGLISH));  // FIXME
      }

    private static SesameManager getSesameManager()
      {
        return (SesameManager)ElmoManagerThreadLocal.get();
      }
  }
